Index: c/src/lib/libbsp/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/ChangeLog,v
retrieving revision 1.63
diff -p -u -u -r1.63 ChangeLog
--- c/src/lib/libbsp/ChangeLog	11 Dec 2008 10:27:20 -0000	1.63
+++ c/src/lib/libbsp/ChangeLog	23 Apr 2009 07:54:36 -0000
@@ -1,3 +1,8 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* Makefile.am: Add bspinit.c, a common Init task that manages
+	command line arguments from a BSP.
+
 2008-12-11	Ralf Corsépius <ralf.corsepius@rtems.org>
 
 	* shared/clockdrv_shell.c: Turn warning into error.
Index: c/src/lib/libbsp/Makefile.am
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/Makefile.am,v
retrieving revision 1.25
diff -p -u -u -r1.25 Makefile.am
--- c/src/lib/libbsp/Makefile.am	26 Sep 2008 05:40:00 -0000	1.25
+++ c/src/lib/libbsp/Makefile.am	23 Apr 2009 07:54:36 -0000
@@ -10,10 +10,10 @@ DIST_SUBDIRS = @libbsp_cpu_subdir@
 EXTRA_DIST = MERGE.PROCEDURE bsp.am
 
 # shared
-EXTRA_DIST += shared/bootcard.c shared/bspclean.c shared/bsplibc.c \
-    shared/bsppost.c shared/console-polled.c shared/console.c \
-    shared/gnatinstallhandler.c shared/sbrk.c shared/tod.c \
-    shared/tod.h
+EXTRA_DIST += shared/bootcard.c shared/bspclean.c shared/bspinit.c \
+    shared/bsplibc.c shared/bsppost.c shared/console-polled.c \
+    shared/console.c shared/gnatinstallhandler.c shared/sbrk.c \
+    shared/tod.c shared/tod.h
 EXTRA_DIST += shared/vmeUniverse/vmeUniverse.c \
     shared/vmeUniverse/vmeUniverse.h \
     shared/vmeUniverse/vmeUniverseDMA.h \
Index: c/src/lib/libbsp/i386/pc386/Makefile.am
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/Makefile.am,v
retrieving revision 1.50
diff -p -u -u -r1.50 Makefile.am
--- c/src/lib/libbsp/i386/pc386/Makefile.am	2 Oct 2008 13:50:44 -0000	1.50
+++ c/src/lib/libbsp/i386/pc386/Makefile.am	23 Apr 2009 07:54:37 -0000
@@ -89,10 +89,10 @@ include_HEADERS += ../../i386/shared/com
 # startup
 libbsp_a_SOURCES += ../../shared/bsplibc.c ../../shared/bsppost.c \
     ../../shared/bsppredriverhook.c startup/bspgetworkarea.c \
-    ../../shared/bsppretaskinghook.c startup/bspstart.c \
+    ../../shared/bsppretaskinghook.c startup/bspstart.c startup/bspcmdline.c \
     ../../shared/bspclean.c startup/bspreset.c ../../i386/shared/irq/idt.c \
     ../../i386/shared/irq/irq.c ../../i386/shared/irq/irq_init.c \
-    ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/bootcard.c ../../shared/bspinit.c ../../shared/sbrk.c \
     startup/ldsegs.S ../../i386/shared/irq/irq_asm.S
 
 # timer
Index: c/src/lib/libbsp/i386/pc386/console/console.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/console/console.c,v
retrieving revision 1.40
diff -p -u -u -r1.40 console.c
--- c/src/lib/libbsp/i386/pc386/console/console.c	3 Nov 2008 20:57:38 -0000	1.40
+++ c/src/lib/libbsp/i386/pc386/console/console.c	23 Apr 2009 07:54:37 -0000
@@ -149,7 +149,34 @@ console_initialize(rtems_device_major_nu
                    void                      *arg)
 {
   rtems_status_code status;
+  const char* mode;
+  
+  /*
+   * Check the command line for the type of mode
+   * the consol is.
+   */
+  mode = bsp_cmdline_arg ("--console=");
 
+  if (mode)
+  {
+    mode += sizeof ("--console=") - 1;
+    if (strncmp (mode, "console", sizeof ("console") - 1) == 0)
+    {
+      BSPConsolePort = BSP_CONSOLE_PORT_CONSOLE;
+      BSPPrintkPort  = BSP_CONSOLE_PORT_CONSOLE;
+    }
+    else if (strncmp (mode, "com1", sizeof ("com1") - 1) == 0)
+    {
+      BSPConsolePort = BSP_UART_COM1;
+      BSPPrintkPort  = BSP_UART_COM1;
+    }
+    else if (strncmp (mode, "com2", sizeof ("com2") - 1) == 0)
+    {
+      BSPConsolePort = BSP_UART_COM2;
+      BSPPrintkPort  = BSP_UART_COM2;
+    }
+  }
+  
   /* Initialize the KBD interface */
   kbd_init();
 
Index: c/src/lib/libbsp/i386/pc386/ide/ide.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/ide/ide.c,v
retrieving revision 1.10
diff -p -u -u -r1.10 ide.c
--- c/src/lib/libbsp/i386/pc386/ide/ide.c	6 Sep 2008 17:04:47 -0000	1.10
+++ c/src/lib/libbsp/i386/pc386/ide/ide.c	23 Apr 2009 07:54:37 -0000
@@ -3,6 +3,9 @@
 +-----------------------------------------------------------------+
 | File: ide.c                                                     |
 +-----------------------------------------------------------------+
+|                                                                 |
+|       Copyright those who have fixed bugs and made changes.     |
+|                                                                 |
 |                    Copyright (c) 2003 IMD                       |
 |      Ingenieurbuero fuer Microcomputertechnik Th. Doerfler      |
 |               <Thomas.Doerfler@imd-systems.de>                  |
@@ -30,6 +33,51 @@
 #include <libchip/ide_ctrl_io.h>
 
 /* #define DEBUG_OUT */
+
+static bool pc386_ide_status_busy (uint32_t port,
+                                   uint32_t timeout,
+                                   uint8_t* status_val)
+{
+  do
+  {
+    inport_byte (port + IDE_REGISTER_STATUS, *status_val);
+    if ((*status_val & IDE_REGISTER_STATUS_BSY) == 0)
+      return true;
+
+    if (timeout)
+    {
+      timeout--;
+      rtems_task_wake_after (TOD_MICROSECONDS_TO_TICKS (1000));
+    }
+  }
+  while (timeout);
+
+  return false;
+}
+
+static bool pc386_ide_status_data_ready (uint32_t port,
+                                         uint32_t timeout,
+                                         uint8_t* status_val)
+{
+  do
+  {
+    inport_byte (port + IDE_REGISTER_STATUS, *status_val);
+    
+    if (((*status_val & IDE_REGISTER_STATUS_BSY) == 0) &&
+        (*status_val & IDE_REGISTER_STATUS_DRQ))
+      return true;
+
+    if (timeout)
+    {
+      timeout--;
+      rtems_task_wake_after (TOD_MICROSECONDS_TO_TICKS (1000));
+    }
+  }
+  while (timeout);
+
+  return false;
+}
+
 /*
  * support functions for IDE harddisk IF
  */
@@ -174,18 +222,28 @@ void pc386_ide_read_block
   uint32_t    port = IDE_Controller_Table[minor].port1;
   uint16_t    cnt = 0;
   uint32_t    llength = bufs[(*cbuf)].length;
-  uint8_t   status_val;
+  uint8_t     status_val;
   uint16_t   *lbuf = (uint16_t*)
     ((uint8_t*)(bufs[(*cbuf)].buffer) + (*pos));
 
-  inport_byte(port+IDE_REGISTER_STATUS,status_val);
-  while ((status_val & IDE_REGISTER_STATUS_DRQ) &&
-	 (cnt < block_size)) {
+  while (cnt < block_size)
+  {
+    if (!pc386_ide_status_data_ready (port, 100, &status_val))
+    {
+      printk ("pc386_ide_read_block: status=%02x, cnt=%d bs=%d\n", status_val, cnt, block_size);
+      /* FIXME: add an error here. */
+      return;
+    }
+    
+    if (status_val & IDE_REGISTER_STATUS_ERR)
+      printk("pc386_ide_read_block: error: %02x\n", status_val);
+    
     inport_word(port+IDE_REGISTER_DATA,*lbuf);
 
 #ifdef DEBUG_OUT
     printk("0x%x ",*lbuf);
 #endif
+
     lbuf++;
     cnt    += sizeof(*lbuf);
     (*pos) += sizeof(*lbuf);
@@ -195,11 +253,7 @@ void pc386_ide_read_block
       lbuf = bufs[(*cbuf)].buffer;
       llength = bufs[(*cbuf)].length;
     }
-    inport_byte(port+IDE_REGISTER_STATUS,status_val);
   }
-#ifdef DEBUG_OUT
-  printk("pc386_ide_read_block()\r\n");
-#endif
 }
 
 /*=========================================================================*\
@@ -230,13 +284,23 @@ void pc386_ide_write_block
   uint8_t     status_val;
   uint16_t   *lbuf = (uint16_t*)
     ((uint8_t*)(bufs[(*cbuf)].buffer) + (*pos));
-
+  
 #ifdef DEBUG_OUT
-  printk("pc386_ide_write_block()\r\n");
+  printk("pc386_ide_write_block()\n");
 #endif
-  inport_byte(port+IDE_REGISTER_STATUS,status_val);
-  while ((status_val & IDE_REGISTER_STATUS_DRQ) &&
-	 (cnt < block_size)) {
+
+  while (cnt < block_size)
+  {
+    if (!pc386_ide_status_data_ready (port, 100, &status_val))
+    {
+      printk ("pc386_ide_write_block: status=%02x, cnt=%d bs=%d\n", status_val, cnt, block_size);
+      /* FIXME: add an error here. */
+      return;
+    }
+    
+    if (status_val & IDE_REGISTER_STATUS_ERR)
+      printk("pc386_ide_write_block: error: %02x\n", status_val);
+    
 #ifdef DEBUG_OUT
     printk("0x%x ",*lbuf);
 #endif
@@ -250,7 +314,6 @@ void pc386_ide_write_block
       lbuf = bufs[(*cbuf)].buffer;
       llength = bufs[(*cbuf)].length;
     }
-    inport_byte(port+IDE_REGISTER_STATUS,status_val);
   }
 }
 
Index: c/src/lib/libbsp/i386/pc386/ide/idecfg.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/ide/idecfg.c,v
retrieving revision 1.6
diff -p -u -u -r1.6 idecfg.c
--- c/src/lib/libbsp/i386/pc386/ide/idecfg.c	29 Sep 2005 08:05:32 -0000	1.6
+++ c/src/lib/libbsp/i386/pc386/ide/idecfg.c	23 Apr 2009 07:54:37 -0000
@@ -35,7 +35,6 @@ extern ide_ctrl_fns_t pc386_ide_ctrl_fns
 
 /* IDE controllers Table */
 ide_controller_bsp_table_t IDE_Controller_Table[] = {
-#if IDE_USE_PRIMARY_INTERFACE
   {"/dev/ide0",
    IDE_STD, /* standard IDE controller */
    &pc386_ide_ctrl_fns,
@@ -45,11 +44,7 @@ ide_controller_bsp_table_t IDE_Controlle
    FALSE,0, /* not (yet) interrupt driven */
    NULL
   }
-#if IDE_USE_SECONDARY_INTERFACE
   , /* colon only needed when both interfaces present */
-#endif
-#endif
-#if IDE_USE_SECONDARY_INTERFACE
   {"/dev/ide1",
    IDE_STD, /* standard IDE controller */
    &pc386_ide_ctrl_fns,
@@ -59,9 +54,74 @@ ide_controller_bsp_table_t IDE_Controlle
    FALSE,0, /* not (yet) interrupt driven */
    NULL
   }
-#endif
 };
 
-/* Number of rows in IDE_Controller_Table */
-unsigned long IDE_Controller_Count =
-   sizeof(IDE_Controller_Table)/sizeof(IDE_Controller_Table[0]);
+/* Number of rows in IDE_Controller_Table. Default is 0. */
+unsigned long IDE_Controller_Count;
+
+#if IDE_USE_PRIMARY_INTERFACE
+#define IDE1_DEFAULT true
+#else
+#define IDE1_DEFAULT false
+#endif
+#if IDE_USE_SECONDARY_INTERFACE
+#define IDE2_DEFAULT true
+#else
+#define IDE2_DEFAULT false
+#endif
+
+void bsp_ide_cmdline_init(void)
+{
+  bool ide1 = IDE1_DEFAULT;
+  bool ide2 = IDE2_DEFAULT;
+  const char* ide;
+  
+  /*
+   * Can have:
+   *  --ide=1,2
+   */
+  ide = bsp_cmdline_arg ("--ide=");
+  
+  if (ide)
+  {
+    int i;
+    /*
+     * If a command line option exists remove the defaults.
+     */
+    ide1 = ide2 = false;
+    
+    ide += sizeof ("--ide=") - 1;
+    
+    for (i = 0; i < 3; i++)
+    {
+      switch (ide[i])
+      {
+        case '1':
+          ide1 = true;
+          break;
+        case '2':
+          ide2 = true;
+          break;
+        case '3':
+        case '4':
+        case '5':
+        case '6':
+        case '7':
+        case '8':
+        case '9':
+        case ',':
+          break;
+        default:
+        break;
+      }
+    }
+  }
+
+  if (ide2 && !ide1)
+    IDE_Controller_Table[0] = IDE_Controller_Table[1];
+
+  if (ide1)
+    IDE_Controller_Count++;
+  if (ide2)
+    IDE_Controller_Count++;
+}
Index: c/src/lib/libbsp/i386/pc386/include/bsp.h
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/include/bsp.h,v
retrieving revision 1.40
diff -p -u -u -r1.40 bsp.h
--- c/src/lib/libbsp/i386/pc386/include/bsp.h	22 Sep 2008 21:49:43 -0000	1.40
+++ c/src/lib/libbsp/i386/pc386/include/bsp.h	23 Apr 2009 07:54:37 -0000
@@ -183,6 +183,17 @@ void Wait_X_ms(unsigned int timeToWait);
 #define BSP_CONSOLE_PORT_COM2    (BSP_UART_COM2)
 
 /*
+ * Command line.
+ */
+const char* bsp_cmdline(void);
+const char* bsp_cmdline_arg(const char* arg);
+
+/*
+ * IDE command line parsing.
+ */
+void bsp_ide_cmdline_init(void);
+
+/*
  * indicate, that BSP has IDE driver
  */
 #define RTEMS_BSP_HAS_IDE_DRIVER
Index: c/src/lib/libbsp/i386/pc386/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/start/start.S,v
retrieving revision 1.11
diff -p -u -u -r1.11 start.S
--- c/src/lib/libbsp/i386/pc386/start/start.S	22 Mar 2008 14:01:49 -0000	1.11
+++ c/src/lib/libbsp/i386/pc386/start/start.S	23 Apr 2009 07:54:38 -0000
@@ -88,21 +88,42 @@ speakl:	jmp	speakl             # and SPI
         cli			# DISABLE INTERRUPTS!!!
 	cld
 
-		/* Save multiboot info */
-		cmp 	$0x2badb002,eax
-		jne		1f
-		/* We have multiboot info; let's hope DS and ES are OK... */
-		movl	ebx, SYM(_boot_multiboot_info_p)
-		/* Check for memory size info and save */
-		movl	ebx, esi
-		movl	$SYM(_boot_multiboot_info), edi
-		movsd
-		/* only save flag 1 since that's the only data we save */
-		and		$1,-4(edi)
-		je		1f
-		movl	$2,ecx
-		rep movsd
-1:
+	/* Save multiboot info if we detect a multiboot loader */
+	cmp 	$0x2badb002,eax
+	jne	2f
+	
+	/* We have multiboot info; let's hope DS and ES are OK... */
+	movl	ebx, SYM(_boot_multiboot_info_p)
+	/* Check for memory size info and save */
+	movl	ebx, esi
+	movl	(esi), eax
+	movl	eax, ebx
+	movl	$SYM(_boot_multiboot_info), edi
+ 	/* save flags, always present */
+	movsd
+	/* flag 1 is memory */
+	and	$1, eax
+	je	1f
+	movl	$2, ecx
+	rep movsd
+	/* flag 2 is the command line */
+1:	movl	ebx, eax
+	and	$4, eax
+	je	3f
+	movl    (_boot_multiboot_info_p), eax
+	movl    16(eax), esi
+	movl	$255, ecx
+2:	movzbl	(esi), eax
+	test	al, al
+	je	3f
+	movb	al, (edi)
+	inc	edi
+	inc	esi
+	dec	ecx
+	je	3f
+	jmp	2b
+3:	xor	al, al
+	movb	al, (edi)
 #ifdef DEBUG_EARLY_START
 	/*
 	 * Must get video attribute to have a working printk.
@@ -178,11 +199,10 @@ SYM (zero_bss):
 | Transfer control to User's Board Support Package
 +---------------------------------------------------------------------*/
 
-	pushl	$0			# environp
-	pushl	$0			# argv
-        pushl	$0			# argc
+	movl	$SYM(_boot_multiboot_cmdline), eax
+	pushl	eax			# cmdline
 	call	SYM (boot_card)
-	addl	$12, esp
+	addl	$4, esp
 
 /*---------------------------------------------------------------------+
 | Clean up - we do not know anything about it, so we will
@@ -199,11 +219,20 @@ SYM(_boot_multiboot_info_p):
 	.long 0
 
 	PUBLIC(_boot_multiboot_info)
+	PUBLIC(_boot_multiboot_flags)
+	PUBLIC(_boot_multiboot_memory)
+	PUBLIC(_boot_multiboot_cmdline)
 SYM(_boot_multiboot_info):
+SYM(_boot_multiboot_flags):
 	.long 0	/* flags */
+SYM(_boot_multiboot_memory):
 	.long 0 /* mem_lower */
 	.long 0 /* mem_upper */
-
+SYM(_boot_multiboot_cmdline):
+	.rept 256 /* cmd line */
+	.byte 0
+	.endr
+	
 	PUBLIC(_stack_size)
 SYM(_stack_size):
 	.long STACK_SIZE
Index: c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c
===================================================================
RCS file: c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c
diff -N c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ c/src/lib/libbsp/i386/pc386/startup/bspcmdline.c	23 Apr 2009 07:54:38 -0000
@@ -0,0 +1,62 @@
+/*-------------------------------------------------------------------------+
+| This file contains the PC386 BSP startup package. It includes application,
+| board, and monitor specific initialization and configuration. The generic CPU
+| dependent initialization has been performed before this routine is invoked.
++--------------------------------------------------------------------------+
+| (C) Copyright 2009 RTEMS Project
+|     Chris Johns (chrisj@rtems.org)
++--------------------------------------------------------------------------+
+| Disclaimer:
+|
+| This file is provided "AS IS" without warranty of any kind, either
+| expressed or implied.
++--------------------------------------------------------------------------+
+| This code is based on:
+|   common sense
+| With the following copyright notice:
+| **************************************************************************
+| *  COPYRIGHT (c) 1989-2008.
+| *  On-Line Applications Research Corporation (OAR).
+| *
+| *  The license and distribution terms for this file may be
+| *  found in found in the file LICENSE in this distribution or at
+| *  http://www.rtems.com/license/LICENSE.
+| **************************************************************************
+|
+|  $Id: bspstart.c,v 1.47 2008/09/18 20:41:09 joel Exp $
++--------------------------------------------------------------------------*/
+
+#include <bsp.h>
+#include <rtems/pci.h>
+#include <libcpu/cpuModel.h>
+
+/*
+ *  External data
+ */
+extern uint32_t _boot_multiboot_flags;
+extern uint32_t _boot_multiboot_memory[2];
+extern const char _boot_multiboot_cmdline[256];
+
+/*-------------------------------------------------------------------------+
+|         Function: bsp_cmdline
+|      Description: Call when you want the command line.
+| Global Variables: The multiboot values copied from the loader.
+|        Arguments: None.
+|          Returns: The whole command line.
++--------------------------------------------------------------------------*/
+const char* bsp_cmdline( void )
+{
+  return _boot_multiboot_cmdline;
+}
+
+/*-------------------------------------------------------------------------+
+|         Function: bsp_cmdline_arg
+|      Description: Call to search for an argument.
+| Global Variables: The multiboot values copied from the loader.
+|        Arguments: The option start.
+|          Returns: The option if found or nothing.
++--------------------------------------------------------------------------*/
+const char* bsp_cmdline_arg( const char* arg )
+{
+  return strstr (bsp_cmdline (), arg);
+}
Index: c/src/lib/libbsp/i386/pc386/startup/bspstart.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/startup/bspstart.c,v
retrieving revision 1.47
diff -p -u -u -r1.47 bspstart.c
--- c/src/lib/libbsp/i386/pc386/startup/bspstart.c	18 Sep 2008 20:41:09 -0000	1.47
+++ c/src/lib/libbsp/i386/pc386/startup/bspstart.c	23 Apr 2009 07:54:38 -0000
@@ -78,6 +78,9 @@ void bsp_start_default( void )
   if (pci_init_retval != PCIB_ERR_SUCCESS) {
       printk("PCI bus: could not initialize PCI BIOS interface\n");
   }
+
+  bsp_ide_cmdline_init ();
+
 } /* bsp_start */
 
 /*
Index: c/src/lib/libbsp/shared/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/shared/ChangeLog,v
retrieving revision 1.136
diff -p -u -u -r1.136 ChangeLog
--- c/src/lib/libbsp/shared/ChangeLog	10 Mar 2009 17:40:06 -0000	1.136
+++ c/src/lib/libbsp/shared/ChangeLog	23 Apr 2009 07:54:38 -0000
@@ -1,3 +1,9 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* bootcard.c, include/bootcard.h: Remove argc/argv/envp and
+	replace with a single BSP boot command line a BSP can optionally
+	support.
+
 2009-03-10	Eric Norum <norume@aps.anl.gov>
 
 	* bootcard.c: Swap order of RTEMS Workspace and Malloc Heap. This
Index: c/src/lib/libbsp/shared/bootcard.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/shared/bootcard.c,v
retrieving revision 1.42
diff -p -u -u -r1.42 bootcard.c
--- c/src/lib/libbsp/shared/bootcard.c	10 Mar 2009 17:40:06 -0000	1.42
+++ c/src/lib/libbsp/shared/bootcard.c	23 Apr 2009 07:54:38 -0000
@@ -48,9 +48,10 @@
 #include <bsp/bootcard.h>
 
 /*
- *  Since there is a forward reference
+ *  At most a single pointer to the cmdline for those target
+ *  short on memory and not supporting a command line.
  */
-char *rtems_progname;
+const char *bsp_boot_cmdline;
 
 /*
  * Are we using a single heap for the RTEMS Workspace and C Program Heap?
@@ -114,21 +115,15 @@ static rtems_status_code bootcard_bsp_li
  *  as much as possible.
  */
 int boot_card(
-  int    argc, 
-  char **argv, 
-  char **envp
+  const char *cmdline
 )
 {
-  static char            *argv_pointer = NULL;
-  static char            *envp_pointer = NULL;
-  char                  **argv_p = &argv_pointer;
-  char                  **envp_p = &envp_pointer;
-  rtems_interrupt_level   bsp_isr_level;
-  rtems_status_code       sc = RTEMS_SUCCESSFUL;
-  void                   *work_area_start = NULL;
-  intptr_t                work_area_size = 0;
-  void                   *heap_start = NULL;
-  intptr_t                heap_size = 0;
+  rtems_interrupt_level  bsp_isr_level;
+  rtems_status_code      sc = RTEMS_SUCCESSFUL;
+  void                  *work_area_start = NULL;
+  intptr_t               work_area_size = 0;
+  void                  *heap_start = NULL;
+  intptr_t               heap_size = 0;
 
   /*
    * Special case for PowerPC: The interrupt disable mask is stored in SPRG0.
@@ -143,22 +138,7 @@ int boot_card(
    */
   rtems_interrupt_disable( bsp_isr_level );
 
-  /*
-   *  Set things up so we have real pointers for argv and envp.
-   *  If the BSP has passed us something useful, then pass it on.
-   *  Somehow we need to eventually make this available to
-   *  a real main() in user land. :)
-   */
-  if ( argv ) argv_p = argv;
-  if ( envp ) envp_p = envp;
-
-  /*
-   *  Set the program name in case some application cares.
-   */
-  if ((argc > 0) && argv && argv[0])
-    rtems_progname = argv[0];
-  else
-    rtems_progname = "RTEMS";
+  bsp_boot_cmdline = cmdline;
 
   /*
    * Invoke Board Support Package initialization routine written in C.
@@ -169,7 +149,8 @@ int boot_card(
    *  Find out where the block of memory the BSP will use for
    *  the RTEMS Workspace and the C Program Heap is.
    */
-  bsp_get_work_area(&work_area_start, &work_area_size, &heap_start, &heap_size);
+  bsp_get_work_area(&work_area_start, (ssize_t*) &work_area_size,
+                    &heap_start, (ssize_t*) &heap_size);
 
   if ( work_area_size <= Configuration.work_space_size ) {
     printk( "bootcard: Work space too big for work area!\n");
Index: c/src/lib/libbsp/shared/bspinit.c
===================================================================
RCS file: c/src/lib/libbsp/shared/bspinit.c
diff -N c/src/lib/libbsp/shared/bspinit.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ c/src/lib/libbsp/shared/bspinit.c	23 Apr 2009 07:54:38 -0000
@@ -0,0 +1,93 @@
+/*
+ *  COPYRIGHT (c) 1989-2009.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id: bspstart.c,v 1.1 2008/09/16 19:10:15 joel Exp $
+ */
+
+#include <stdlib.h>
+#include <string.h>
+
+#include <bsp.h>
+#include <bsp/bootcard.h>
+
+/*
+ * This routine calls main from a confdefs.h default Init task
+ * set up. The bootcard will provide the task argument as
+ * command line string (ASCIIZ).
+ */
+
+int main (int argc, char* argv[]);
+
+void Init (rtems_task_argument arg)
+{
+  const char* boot_cmdline = *((const char**) arg);
+  char*       cmdline = 0;
+  char*       command;
+  int         argc = 0;
+  char**      argv = NULL;
+  int         result = -124;
+
+  if (boot_cmdline)
+  {
+    cmdline = malloc (strlen (boot_cmdline) + 1);
+  
+    if (cmdline)
+    {
+      strcpy (cmdline, boot_cmdline);
+
+      command = cmdline;
+
+      /*
+       * Break the line up into arguments with "" being ignored.
+       */
+      while (true)
+      {
+        command = strtok (command, " \t\r\n");
+        if (command == NULL)
+          break;
+        argc++;
+        command = '\0';
+      }
+
+      argv = calloc (argc, sizeof (char*));
+
+      if (argv)
+      {
+        int a;
+        
+        command = cmdline;
+        argv[0] = command;
+
+        for (a = 1; a < argc; a++)
+        {
+          command += strlen (command) + 1;
+          argv[a] = command;
+        }
+      }
+      else
+        argc = 0;
+    }
+  }
+  
+#ifdef RTEMS_NETWORKING
+  rtems_bsdnet_initialize_network ();
+#endif
+
+  result = main (argc, argv);
+ 
+  free (argv);
+  free (cmdline);
+
+  exit (result);
+}
+
+/*
+ * By making this a weak alias and a user can provide there own.
+ */
+
+void Init (rtems_task_argument arg) __attribute__ ((weak));
Index: c/src/lib/libbsp/shared/include/bootcard.h
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/shared/include/bootcard.h,v
retrieving revision 1.5
diff -p -u -u -r1.5 bootcard.h
--- c/src/lib/libbsp/shared/include/bootcard.h	2 Oct 2008 19:13:05 -0000	1.5
+++ c/src/lib/libbsp/shared/include/bootcard.h	23 Apr 2009 07:54:38 -0000
@@ -60,7 +60,7 @@ void bsp_get_work_area(
   ssize_t  *heap_size
 );
 
-int boot_card( int argc, char **argv, char **envp);
+int boot_card( const char *cmdline );
 
 void bsp_libc_init( void *heap_start, size_t heap_size, size_t sbrk_amount);
 
Index: c/src/libchip/ide/ata.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/libchip/ide/ata.c,v
retrieving revision 1.22
diff -p -u -u -r1.22 ata.c
--- c/src/libchip/ide/ata.c	7 Sep 2008 03:35:29 -0000	1.22
+++ c/src/libchip/ide/ata.c	23 Apr 2009 07:54:39 -0000
@@ -608,6 +608,10 @@ ata_non_data_request_done(ata_req_t *are
                           rtems_device_minor_number ctrl_minor,
                           rtems_status_code status, int error)
 {
+#ifdef DEBUG
+    printf("ata_non_data_request_done: entry\n");
+#endif
+    
     areq->status = status;
     areq->error = error;
     rtems_semaphore_release(areq->sema);
@@ -638,7 +642,7 @@ ata_add_to_controller_queue(rtems_device
 
         ata_queue_msg_t msg;
 
-#ifdef DEBUG
+#ifdef DEBUG_DOES_NOT_WORK_WITH_QEMU
 	uint16_t      val;
         /*
          * read IDE_REGISTER_ALTERNATE_STATUS instead IDE_REGISTER_STATUS
@@ -1289,7 +1293,7 @@ rtems_ata_initialize(rtems_device_major_
                                           IDE_REGISTER_DEVICE_CONTROL_OFFSET,
                                           IDE_REGISTER_DEVICE_CONTROL_nIEN);
         }
-
+#if 0
         /*
          * Issue EXECUTE DEVICE DIAGNOSTIC ATA command for explore is
          * there any ATA device on the controller.
@@ -1315,7 +1319,8 @@ rtems_ata_initialize(rtems_device_major_
          */
         if (breq.req.status != RTEMS_SUCCESSFUL)
             continue;
-
+#endif
+        breq.req.error = ATA_DEV0_PASSED_DEV1_PASSED_OR_NOT_PRSNT;
         /* disassemble returned diagnostic codes */
         if (breq.req.error == ATA_DEV0_PASSED_DEV1_PASSED_OR_NOT_PRSNT)
         {
Index: c/src/libchip/ide/ide_controller.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/libchip/ide/ide_controller.c,v
retrieving revision 1.9
diff -p -u -u -r1.9 ide_controller.c
--- c/src/libchip/ide/ide_controller.c	29 Jul 2008 02:23:48 -0000	1.9
+++ c/src/libchip/ide/ide_controller.c	23 Apr 2009 07:54:39 -0000
@@ -25,7 +25,7 @@
 #include <libchip/ide_ctrl_io.h>
 
 #if IDE_CONTROLLER_TRACE
-int ide_controller_trace;
+int ide_controller_trace = 1;
 #endif
 
 /*
Index: cpukit/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/ChangeLog,v
retrieving revision 1.1772
diff -p -u -u -r1.1772 ChangeLog
--- cpukit/ChangeLog	15 Apr 2009 08:36:12 -0000	1.1772
+++ cpukit/ChangeLog	23 Apr 2009 07:54:39 -0000
@@ -1,3 +1,9 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* sapi/include/confdefs.h: Add a prototype for Init with C linkage
+	and define Init task command line arguments if confdefs.h provides
+	an Init entry point.
+
 2009-04-15	Ralf Corsepius <ralf.corsepius@rtems.org>
 
 	* configure.ac: Disable LIBSHELL for unix targets.
Index: cpukit/libblock/include/rtems/ide_part_table.h
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libblock/include/rtems/ide_part_table.h,v
retrieving revision 1.11
diff -p -u -u -r1.11 ide_part_table.h
--- cpukit/libblock/include/rtems/ide_part_table.h	29 Jul 2008 02:21:14 -0000	1.11
+++ cpukit/libblock/include/rtems/ide_part_table.h	23 Apr 2009 07:54:39 -0000
@@ -51,6 +51,7 @@
 #define RTEMS_IDE_PARTITION_MSDOS_SIGNATURE_DATA2         0xaa
 #define RTEMS_IDE_PARTITION_MSDOS_SIGNATURE_OFFSET        0x1fe
 #define RTEMS_IDE_PARTITION_TABLE_OFFSET                  0x1be
+#define RTEMS_IDE_PARTITION_TABLE_SIZE                    (4 * 16)
 #define RTEMS_IDE_PARTITION_BOOTABLE_OFFSET               0
 #define RTEMS_IDE_PARTITION_SYS_TYPE_OFFSET               4
 #define RTEMS_IDE_PARTITION_START_OFFSET                  8
Index: cpukit/libblock/src/bdbuf.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libblock/src/bdbuf.c,v
retrieving revision 1.28
diff -p -u -u -r1.28 bdbuf.c
--- cpukit/libblock/src/bdbuf.c	16 Dec 2008 20:53:33 -0000	1.28
+++ cpukit/libblock/src/bdbuf.c	23 Apr 2009 07:54:39 -0000
@@ -1639,9 +1639,17 @@ rtems_bdbuf_read (dev_t                d
      * enabled and the pool unlocked. This is a change to the previous version
      * of the bdbuf code.
      */
-    int      result;
-    uint32_t b;
-    
+    rtems_event_set out;
+    int             result;
+    uint32_t        b;
+
+    /*
+     * Flush any events.
+     */
+    rtems_event_receive (RTEMS_BDBUF_TRANSFER_SYNC,
+                         RTEMS_EVENT_ALL | RTEMS_NO_WAIT,
+                         0, &out);
+                         
     rtems_bdbuf_unlock_pool (pool);
 
     req->req = RTEMS_BLKDEV_REQ_READ;
@@ -1665,7 +1673,7 @@ rtems_bdbuf_read (dev_t                d
     else
     {
       rtems_status_code sc;
-      rtems_event_set   out;
+      
       sc = rtems_event_receive (RTEMS_BDBUF_TRANSFER_SYNC,
                                 RTEMS_EVENT_ALL | RTEMS_WAIT,
                                 0, &out);
Index: cpukit/libblock/src/ide_part_table.c
===================================================================
RCS file: /usr1/CVS/rtems/cpukit/libblock/src/ide_part_table.c,v
retrieving revision 1.13
diff -p -u -u -r1.13 ide_part_table.c
--- cpukit/libblock/src/ide_part_table.c	19 Dec 2008 14:59:35 -0000	1.13
+++ cpukit/libblock/src/ide_part_table.c	23 Apr 2009 07:54:39 -0000
@@ -57,7 +57,8 @@ get_sector(dev_t dev, uint32_t sector_nu
         return RTEMS_INTERNAL_ERROR;
     }
 
-    s = (rtems_sector_data_t *) malloc(sizeof(rtems_sector_data_t) + RTEMS_IDE_SECTOR_SIZE);
+    s = (rtems_sector_data_t *) malloc(sizeof(rtems_sector_data_t) +
+                                       RTEMS_IDE_SECTOR_SIZE);
     if (s == NULL)
     {
         return RTEMS_NO_MEMORY;
@@ -131,16 +132,17 @@ static bool
 is_fat_partition(uint8_t type)
 {
   static const uint8_t fat_part_types[] = {
-    DOS_FAT12_PARTITION,DOS_FAT16_PARTITION,
+    DOS_FAT12_PARTITION,
+    DOS_FAT16_PARTITION,
     DOS_P32MB_PARTITION,
-    FAT32_PARTITION    ,FAT32_LBA_PARTITION,
+    FAT32_PARTITION,
+    FAT32_LBA_PARTITION,
     FAT16_LBA_PARTITION
   };
 
   return (NULL != memchr(fat_part_types,type,sizeof(fat_part_types)));
 }
 
-
 /*
  * data_to_part_desc --
  *      parses raw partition table sector data
@@ -433,7 +435,9 @@ rtems_ide_part_table_free(rtems_disk_des
 {
     int part_num;
 
-    for (part_num = 0; part_num < RTEMS_IDE_PARTITION_MAX_SUB_PARTITION_NUMBER; part_num++)
+    for (part_num = 0;
+         part_num < RTEMS_IDE_PARTITION_MAX_SUB_PARTITION_NUMBER;
+         part_num++)
     {
         partition_free(disk_desc->partitions[part_num]);
     }
